using System.IO;
using System.Web.Mvc;

namespace SmartStore.Services.Seo
{
    /// <summary>
    /// Represents a sitemap generator
    /// </summary>
    public partial interface ISitemapGenerator
    {
        /// <summary>
        /// This will build an xml sitemap for better index with search engines.
        /// See http://en.wikipedia.org/wiki/Sitemaps for more information.
        /// </summary>
		/// <param name="urlHelper">URL helper</param>
        /// <returns>Sitemap.xml as string</returns>
		string Generate(UrlHelper urlHelper);

        /// <summary>
        /// This will build an xml sitemap for better index with search engines.
        /// See http://en.wikipedia.org/wiki/Sitemaps for more information.
        /// </summary>
		/// <param name="urlHelper">URL helper</param>
        /// <param name="stream">Stream of sitemap.</param>
        void Generate(UrlHelper urlHelper, Stream stream);

    }
}
